#!/usr/bin/perl
# Copyright (c) 2000 Mark Stosberg <mark@stosberg.com>
# Licensed under the the GNU GPL, available here: http://www.gnu.org/copyleft/gpl.html

# this script is used to create all the sort keys for the category table
# based on the parent_id. It is useful for migrating from older versions of cascade. 
# before you run this script, you need to have data imported into the category table. 

package Cascade;

# XXX These two variables may need to updated if you are using a non-standard configuration
use lib ('../perllib');
use Cascade::Config;

use Cascade;
use strict;

#######################################################################

# Connect to the Database
$DBH = &connect_db;

#DBI->trace(1);

my $cats_ref = $DBH->selectcol_arrayref("select id from category where parent_id = 0");
	foreach my $id (@$cats_ref){
		my $cat = new Category (id=>$id);
		$cat->update_sort_keys;
	}
	
